package POE::Component::Leve::leveShell;

use warnings;
use strict;

##############################################################################
=pod

=head1 NAME

leveShell

=head1 DESCRIPTION

puts up a terminal interface to the leve system

=head1 AUTHOR

  Bruno Bttcher <bboett at adlp dot org>

=head1 COPYRIGHT and LICENCE

 Copyright (c) 2002 Bruno Boettcher

 leveShell.pl is free software; you can redistribute it and/or
 modify it under the terms of the GNU General Public License
 as published by the Free Software Foundation; version 2
 of the License.

 This program is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General Public License
 along with this program; if not, write to the Free Software
 Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.


=cut

#sub POE::Kernel::ASSERT_EVENTS () { 1 }

use POE qw/Session/;
use vars qw/$VERSION/;
#use Term::ReadLine;
use POE::Wheel::ReadLine;
#use POE::Wheel::Run;
use POE::Filter::Reference;
use Data::Dumper;

$VERSION = sprintf("%d.%02d", q$Revision: 1.3 $ =~ /(\d+)\.(\d+)/);

######################################################################
=pod

=item new 

constructor for the new leve shell

=cut

######################################################################
sub new 
{
  my $fs = shift;
  my $serverName = shift;
  my $o_xchatHandler = { };

  bless $o_xchatHandler, "POE::Component::Leve::leveShell";
  return $o_xchatHandler;
}# sub new 
##############################################################################
=pod

=head1 Methods of this class

=over

=item init

set up the main datastructures of this object, make it ready for the run

=cut

######################################################################
sub init
{
  my($this,$settings) = @_;

$this->{"settings"} ={};
$this->{"settings"} = $settings if($settings);
$this->{"prompt"} = "cmd> ";

POE::Session->create( 
    #Alias => "leveShell",
    object_states => 
    [

    $this =>
    {  _start => "_start",
      _stop  => "_stop",
      'runShell' => "runShell",
      'delegate' => "delegate",
      _default => "_default",
      task_result => "handle_task_result",
      task_done   => "handle_task_done",
      task_debug  => "handle_task_debug",
      got_input  => "got_input_handler",
    },

]
  );
       #$poe_kernel->run();
       print("exiting shell init\n");
}#sub init
##############################################################################
=pod

=item start of the poe session


=cut

######################################################################
sub _start 
{
  my ($this, $kernel, $heap, $dsn, $queries,$session) = @_[OBJECT, KERNEL, HEAP, ARG0, ARG1,SESSION];
  #Debug("_start  args : ".Dumper(\@_)."\n"); 
  $kernel->alias_set("leveShell");
  $this->{"kernel"} = $kernel;
  $this->{"heap"} = $heap;
  #$session->option(default => 1);
  print("_start::SH starting shell\n");
  #$kernel->post('leveShell' => "runShell");
  #$kernel->post('runShell');
	$heap->{"leveShell"} = $this;

  $this->runShell(@_);
  print("success starting shell!!\n");

       #my $task = POE::Wheel::Run->new
       #  ( 
       #   #Program => sub { Debug("reminder  args : ".Dumper(\@_)."\n"); runShell(\@_); },
       #   #Program => runShell(@_),
       #   #Program => &runShell,
       #   #Program => &POE::Component::Leve::leveShell::runShell,
       #   Program => \&runShell,
  
       #    StdoutFilter => POE::Filter::Reference->new(),
       #    StdoutEvent  => "task_result",
       #    StderrEvent  => "task_debug",
       #    CloseEvent   => "task_done",
       #  );

      #  $heap->{task}->{ $task->ID } = $task;

  print("_start::SH posted runshell\n");
}#sub _start
##############################################################################
=pod

=item stop of the poe session


=cut

######################################################################
sub _stop 
{
  my ($this, $kernel, $heap) = @_[OBJECT, KERNEL, HEAP];
  $this->{"heap"} = $heap;
  $this->{"kernel"} = $kernel;
  $kernel->post('debug',"stopped series manager");
}#sub _stop 
##############################################################################
=pod

=item default of the poe session


=cut

######################################################################
sub _default 
{
  my ($this, $kernel, $heap) = @_[OBJECT, KERNEL, HEAP];
  $this->{"heap"} = $heap;
  $this->{"kernel"} = $kernel;
  #print("defaultped ".$_[ARG0]."\n");
  Debug("default ".$_[ARG0])."\n";
 # for (my $i=0; $i < 8 ; $i++)
 #{
 #  my $arg = $_[eval (print("ARG$i"))];
 #  print(" $i= $arg") if($arg); 
 #}# for (my $i=0; $i < 8 ; $i++)
   Debug(" 1= ".Dumper($_[ARG1])) if($_[ARG1]); 
   Debug(" 2= ".Dumper($_[ARG2])) if($_[ARG2]); 
   Debug(" 3= ".Dumper($_[ARG3])) if($_[ARG3]); 
   Debug(" 4= ".Dumper($_[ARG4])) if($_[ARG4]); 
   Debug(" 5= ".Dumper($_[ARG5])) if($_[ARG5]); 
   Debug(" 6= ".Dumper($_[ARG6])) if($_[ARG6]); 
   Debug(" 7= ".Dumper($_[ARG7])) if($_[ARG7]); 
   Debug(" 8= ".Dumper($_[ARG8])) if($_[ARG8]); 
  Debug("\n");
}#sub _default 
##############################################################################
=pod

=item runShell

start and run the shell, this is an interactive process, so it won't exit unlees the user asks for it! this blocks all if not called from the correct spot!


=cut

######################################################################
sub runShell
{
  my ($this) = $_[OBJECT];
  #Debug("Dumping args : ".Dumper(\@_)."\n");
  my $heap = $this->{"heap"};
  my $kernel = $this->{"kernel"};
  $kernel = $_[KERNEL] if(!$kernel);
  $heap = $_[HEAP] if(!$heap);

	if(!$this) 
	{
	  $this = $heap->{"leveShell"} ;
	  Debug("fetchedt ref to object from heap....\n");
	}
	  if(!$this) 
	  {
	  Debug("lost ref to my object....\n");
	  }
	  else
	  {
	  Debug("got back  object reference: ".ref($this)."....\n");
	  }
  Debug("help! we have no kernel defined!!!\n") if(!$kernel);
  #my ($this, $kernel, $heap, $dsn, $queries) = @_[OBJECT, KERNEL, HEAP, ARG0, ARG1];

  #Debug("Entering runShell with this = ".ref($this)." ".Dumper($this)."\n");

  #    my @request = ( 
      #        "help", "series" 
      #        );

  #    $heap->{server}->put( \@request );
  #my $term = new Term::ReadLine 'Leverloda shell';
  #my $term = POE::Wheel::ReadLine->new( InputEvent => "leveShell" => 'got_input' );
  my $term = POE::Wheel::ReadLine->new( InputEvent => 'got_input' );
  $heap->{wheel} = $term;

  #my $prompt = "cmd> ";
  my $prompt = $this->{"prompt"};
  #my $OUT = $term->OUT || \*STDOUT;
  #my $running = 1;
  #add the function handlers
  my $shCommands = do("shellCmds.pm");
  $this->{"shellCmds"} = $shCommands;

  # Trigger the wheel to read a line of input.
  #$heap->{wheel}->get( $prompt );
  
  #Debug("Using readline:".$term->ReadLine ."\n");
  #foreach my $cmd (keys(%{$shCommands}))
  #{
    #   #$term->add_defun($cmd, sub { processCmd($heap,$kernel)});
    #   #$term->rl_completion_matches($cmd);
    #}#foreach my $pattern (@::wishlist)


  #while ( $running && defined ($_ = $term->readline($prompt)) )
  #{
  #  chomp;
  #  Debug("incoming line = $_\n");

  #  if(/shutdown/i)
  #  {
  #    Debug("case shutdown\n");
  #    $running = 0;
  #    my @request = ( "shutdown" );
  #    $this->{"server"}->put( \@request );

  #    $this->quit("Shutting down the server and quitting the processing",$kernel,$heap);
  #  }# if(/shutdown/i)
  #  elsif(/quit/i)
  #  {
  #    Debug("case quit\n");
  #    $running = 0;
  #    $this->quit("exiting the client",$kernel,$heap);
  #  }# if(/shutdown/i)
  #  else
  #  {
  #    Debug("case otherwise\n");
  #    #my @request = ($_);
  #    #print("put $_ in array sending all to server\n");
  #    #$this->{"server"}->put( \@request );
  #    if($kernel)
  #    {
  #    Debug("sending $_ to the server\n");
  #    $kernel->post('delegate',$_);
  #    my @request = ($_);
  #    $this->{"server"}->put( \@request );
  #    Debug("posted $_ to server\n");
  #    }# if($kernel)
  #    else
  #    {
  #      Debug( "can't call delegate $_ saince we have no kernel defined!!\n");
  #    }#else

  #  }# else
  #  $term->addhistory($_) if /\S/;
  #}# while ( $running && defined ($_ = $term->readline($prompt)) )
  #Debug("Exit of the while loop, program end reached\n");
  Debug("Exit of the runShell\n");
}#sub runShell
##############################################################################
=pod

=item quit

shut down the whole thing

=cut

######################################################################
sub quit
{
  my ($this,$msg,$kernel,$heap) = @_;

  Debug("$msg\n");
  $heap->{wheel}->clear();
  $kernel->yield("shutdown");
}#sub quit
##############################################################################
=pod

=item delegate

pipe the stuff through to the server instance

=cut

######################################################################
sub delegate
{
  my ($this, $kernel, $heap, $input, $queries) = @_[OBJECT, KERNEL, HEAP, ARG0, ARG1];

	my @request = ($input);
  Debug("put $input in array sending all to server\n");
  $this->{"server"}->put( \@request );
	#$this->{"server"}->put( \@request );
	#Debug("posted $input to server\n");
}#sub delegate
##############################################################################
=pod

=item handle_task_result

Handle information returned from the task.  Since we're using
POE::Filter::Reference, the $result is however it was created in the
child process.  In this sample, it's a hash reference.

=cut

######################################################################
sub handle_task_result 
{
    my $result = $_[ARG0];
    Debug ("Result for $result->{task}: $result->{status}\n");
}

##############################################################################
=pod

=item handle_task_debug

Catch and display information from the child's STDERR.  This was
useful for debugging since the child's warnings and errors were not
being displayed otherwise.

=cut

######################################################################
sub handle_task_debug 
{
    my $result = $_[ARG0];
    Debug ("Debug: $result\n");
}

##############################################################################
=pod

=item handle_task_done

The task is done.  Delete the child wheel, and try to start a new
task to take its place.

=cut

######################################################################
sub handle_task_done 
{
    my ( $kernel, $heap, $task_id ) = @_[ KERNEL, HEAP, ARG0 ];
    delete $heap->{task}->{$task_id};
    $kernel->yield("next_task");
}
##############################################################################
=pod

=item Debug

print out, to  the console and into a file

=cut

######################################################################
sub Debug
{
  my $msg = shift;
  if(open(DIRLIST,">>debug"))
  {
    print $msg;
    print DIRLIST $msg;
    close( DIRLIST );
  }# if(open(DIRLIST,">>debug"))
}#sub Debug
##############################################################################
=pod

=item server

getter method to set or get the reference to the series server

=cut

######################################################################
sub server
{
  my($this,$server) = @_;

  if($server)
  {
    $this->{"server"} = $server;
  }# if(open(DIRLIST,">>debug"))
  else
  {
    $server = $this->{"server"};
  }# else
  return $server;
}# sub setServer
##############################################################################
=pod

=item got_input_handler

ome input came from the terminal, process it

=cut

######################################################################
sub got_input_handler
{
  my ($this,$heap, $input, $exception,$kernel) = @_[OBJECT,HEAP, ARG0, ARG1,KERNEL];
  
  my $shCommands = $this->{"shellCmds"};
  Debug( "entering got_input_handler\n");

  #Debug("Using readline:".$term->ReadLine ."\n");
  #foreach my $cmd (keys(%{$shCommands}))
  #{
    #   #$term->add_defun($cmd, sub { processCmd($heap,$kernel)});
    #   #$term->rl_completion_matches($cmd);
    #}#foreach my $pattern (@::wishlist)

  if (defined $input)
  {
    my $prompt = $this->{"prompt"};
    $heap->{wheel}->addhistory($input);

    $input = chomp($input);

    Debug("incoming line = $input\n");
    $heap->{wheel}->put("\tGot: $input");


    if($input =~ /shutdown/i)
    {
      Debug("case shutdown\n");
      #$running = 0;
      my @request = ( "shutdown" );
      $this->{"server"}->put( \@request );

      $this->quit("Shutting down the server and quitting the processing",$kernel,$heap);
    }# if(/shutdown/i)
    elsif($input =~ /quit/i)
    {
      Debug("case quit\n");
      #$running = 0;
      $this->quit("exiting the client",$kernel,$heap);
    }# if(/shutdown/i)
    else
    {
      Debug("case otherwise\n");
      #my @request = ($_);
      #print("put $_ in array sending all to server\n");
      #$this->{"server"}->put( \@request );
      if($kernel)
      {
	Debug("sending $input to the server\n");
	$kernel->post('delegate',$input);
	#my @request = ($input);
	#$this->{"server"}->put( \@request );
	#Debug("posted $input to server\n");
      }# if($kernel)
      else
      {
	Debug( "can't call delegate $input since we have no kernel defined!!\n");
      }#else

    }# else
    $this->prompt(); # get another line
  }# if (defined $input)
  else 
  {
    $heap->{wheel}->put("\tException: $exception");
  }
}#sub got_input_handler
##############################################################################
=pod

=item prompt

set the prompt of the terminal

=cut

######################################################################
sub prompt
{
  my ($this,$heap) = @_;
  $heap = $this->{"heap"};

  my $prompt = $this->{"prompt"};
  # Trigger the wheel to read a line of input.
  $heap->{wheel}->get( $prompt );
  #Debug( "issued prompt = $prompt\n");
}#sub prompt
1
__END__


=back

=head1 THANKS

I. Wronsky came up with the concept for leverloda
This gave B. Boettcher the incentive to begin this work, the
famous itching paradigm!

=head1 SEE ALSO

http://www.geocities.com/iwronsky/
http://poe.perl.org/

=cut

