#!/usr/bin/perl
use warnings;
use strict;
sub BEGIN
{
    push (@INC,$ENV{HOME}.'/download/leverloda/goanseech')
        if(!( (join(' ',@INC)) =~ /$ENV{HOME}\/\.leve\/lib/));
}
##############################################################################
=pod

=head1 NAME

patternServer 

=head1 DESCRIPTION

This whole thing is a spinoff of the leverlada irc leech script
http://www.geocities.com/iwronsky/

That thing is a leech script for xchat. The mechanisms that managed the
tracking of series was extracted and refunded in a standalone system that can
be queried over SSL sockets. 

The idea was to have a global series manager that could be queried by multiple
download (aka leech) systems. Actually leverlada was adapted to reread its
series file, since xchat is allergic to POE, the event handler choosen for this
project.

Thus if you use the xchat/leverlada config files, the series manager will keep
also the xchat stuff up to date.

starts up a server and waits for connections that will ask about
one series or another or wants to use the interactive shell.

=head1 ABSTRACT

Lets see if this field is somehow used...

=head1 AUTHOR

  Bruno Bttcher <bboett at adlp dot org>

=head1 COPYRIGHT and LICENCE

 Copyright (c) 2002 Bruno Boettcher

 patternServer.pl.pm is free software; you can redistribute it and/or
 modify it under the terms of the GNU General Public License
 as published by the Free Software Foundation; version 2
 of the License.

 This program is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General Public License
 along with this program; if not, write to the Free Software
 Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.


=head3 instantiating a TCP server

Create a server that receives and sends Perl data structures.  It
will be referred to by the name "sum-server" when necessary.  It
listens on localhost port 12345.  It uses POE::Filter::Reference
to parse input and format output.

=cut

#read the config file
##############################################################################

use Data::Dumper;
#use Carp;
#use sigtrap qw(stack-trace);
#use sigtrap;

#sub POE::Kernel::ASSERT_DEFAULT () { 1 }
#sub POE::Kernel::TRACE_DEFAULT  () { 1 }
sub POE::Kernel::ASSERT_USAGE () { 1 }


use POE;
use POE::Filter::Reference;
use POE::Component::Server::TCP;
use POE::Component::Leve::patternList;
use POE::Component::Leve::printHandler;

use constant FALSE => 0;
use constant TRUE => 1;


my $rootpath = $ENV{HOME}."/.goanseech/";


while(scalar(@ARGV) >0)
{
  my $key = shift(@ARGV);
  if($key =~ /--config/i)
  {
    $rootpath = shift(@ARGV);
  }# if($key =~ /--config/i)
  else
  {
    die("Invalid switch: valid is --config\n");
  }# else
}# if(scalar(@ARGV) >0)
$rootpath .= "/" if(!($rootpath =~ /\/$/));

my $settings = do($rootpath."settings.pm");
my $shCommands = do($rootpath."shellCmds.pm");

my $authenthications = {};
my $printHandlers = {};

print("instantiating patternList\n");
my $handler = new POE::Component::Leve::patternList();
print("instantiating printHandler\n");
my $reporter = new POE::Component::Leve::printHandler();
#print("setting up patternList\n");
$handler->init($settings,$reporter);
#print("Listing wishes:".$handler->series()."\n");
my %clients;

use ServerTcp;

#POE::Component::Server::TCP->new
ServerTcp->new
( Alias => "pattern_server",
  Address      => "localhost",
  Port         => 22345,
  ClientFilter => "POE::Filter::Reference",

  InlineStates       => { send => \&handle_send },

  # Handle client requests here.

  ClientInput => sub { shell(@_);},

  ClientConnected	=> sub { client_connection(@_);},
  

  # to the server itself.  Using yield() here would just shut down
  # the client connection.

  ClientDisconnected => sub 
{
  my ($kernel,$session) = @_[KERNEL,SESSION];
  delete  $authenthications->{$session->ID};
  delete  $clients{$session->ID};
  $kernel->yield("shutdown");
  #$kernel->post( pattern_server => "shutdown" );
},
  ClientError => sub 
{
  my ($kernel,$session,$syscall_name, $error_number, $error_string) = @_[KERNEL,SESSION,ARG0, ARG1, ARG2];
  delete  $authenthications->{$session->ID};
  #delete  $clients{$session->ID};
  rm_printhandler($session->ID,$kernel);
  #print("Some error happened on $syscall_name, $error_number, $error_string\n");
  $kernel->yield("shutdown");
  #$kernel->post( pattern_server => "shutdown" );
},
);

#print("Ready to listen!\n");

### Run the server. 

$poe_kernel->run();
##############################################################################
=pod

=item shell

the method where the incoming data is redirected to, this thing analyzes
partially the incoming stuff and redirects it to the correct isntance or
processes it itself (e.g. commands as shutdown are processed locally, as is the
    authentication)

=cut
######################################################################
sub shell
{
  my ( $heap, $line,$kernel,$session ) = @_[ HEAP, ARG0, KERNEL,SESSION ];
  #print("shell ".Dumper($line)."!\n");


  my $return = " ";
  if ( ref($line) eq 'ARRAY' )
  {
    foreach my $oneLine (@{$line})
    {
      my ($cmd, $args);
      #print("shell::parsing line $oneLine\n");
      if(ref($oneLine) eq 'SCALAR' || !(ref($oneLine)))
      {
	($cmd, $args) = split(/ /,$oneLine,2);
	#print("scalar split into $cmd, $args\n");
      }# if(ref($oneLine) eq 'SCALAR')
      elsif(ref($oneLine) eq 'ARRAY')
      {
	$cmd = shift(@$oneLine);
	$args = shift(@$oneLine);
	#print("array split into $cmd, $args\n");
      }#elsif(ref($oneLine) eq 'ARRAY')
      else
      {
	print("type ".ref($oneLine)." unrecognized... don't know how to process $oneLine\n");
      }# else
      #print("called processCmd with $cmd!\n");

      $return .= processCmd($heap,$cmd, $args,$kernel,$session);
    }
  }# if ( ref($line) eq 'ARRAY' )
  else
  {
    my ($cmd, $args);
    if(ref($line eq 'SCALAR') || !(ref($line)))
    {
      ($cmd, $args) = split(/ /,$line,2);
    }# if(ref($oneLine) eq 'SCALAR')
    elsif(ref($line eq 'ARRAY'))
    {
      $cmd = shift(@$line);
      $args = shift(@$line);
    }#elsif(ref($oneLine) eq 'ARRAY')
    #my ($cmd, $args) = split(/ /,$line,2);
    $return .= processCmd($heap,$cmd, $args,$kernel,$session);
  }# else
  #print("sending jobDone\n");
  if(!($return =~ /noack/i))
  {
    my $msg = "jobDone";
    $heap->{client}->put(\$msg);
  }# if($return && $return =~ /noack/i)
}# sub shell

##############################################################################
=pod

=item issueUsage

fetch all possible commands and regroup them ready to be send to the asking instance... nto very pragmatic, since the ocmmands aren't explained, btu still, gives an idea of what's possible and a hint to search in a eventual docu if the stuff actually does something and what

=cut
######################################################################
sub issueUsage
{
  my $msg = "Usage list of available commands: \n";
  foreach my $cmd (keys(%$shCommands))
  {
    $msg .= "$cmd ";
  }#foreach my $pattern (@::wishlist)
  return "$msg\nEnd of list\n";
}# sub issueUsage
##############################################################################
=pod

=item processCmd

a command was identifyed and now needs to be handled over to the correct handler 

=cut
######################################################################
sub processCmd
{
  my ($heap, $cmd, $args,$kernel,$session) = @_;

  my $msg;
  #print("shell actual session ".$session->ID."\n");
  #$msg = "Detected command: $cmd";
  #$msg .= " with args $args" if($args);
  #$msg .= "\n";

  #print($msg);

  if(!($authenthications->{$session->ID}))
  {
    #user not authentified....
    #print("checking auth $cmd $args\n");
    if($cmd && $cmd =~/^auth/i)
    {
      #print("command is  auth\n");
      my ($login,$passwd) = split(/\s+/,$args,2);
      #print("compare with ".Dumper($settings)."\n");
      #print("vs $login,$passwd\n");
      if(($login eq $settings->{"user"}) && ($passwd eq $settings->{"passwd"}))
      {
	$authenthications->{$session->ID} = 1;
	$msg = "auth successful\n";
	#print("auth ok\n");
      }# if(($login eq $settings->{"user"}) && ($passwd eq $settings->{"passwd"}))
      else
      {
	$msg = "wrong credentials\n";
	#print("auth not ok\n");
      }# else
    }# if($cmd && $cmd =~/^auth/i)
    else
    {
      $msg = "you need to authenticate first\n";
      #print("not authentifiex yet\n");
    }# else
    #print("sending back to client $msg\n");
    $heap->{client}->put(\$msg);
    return " ";
  }# if   $authenthications  

  if(!$cmd)
  {
    $msg = issueUsage();
    #print("sending back to client $msg\n");
    $heap->{client}->put(\$msg);
  }# if(!$cmd)
  elsif($cmd =~ /shutdown/i)
  {
    print("received shutdown call, closin operations\n");
    $handler->save();
    $kernel->post( pattern_server => "shutdown" );
  }#elsif($cmd =~ /shutdown/i)
  elsif($cmd =~ /quit/i)
  {
    #the client send quit, means he want's to stop, but since he doesn't know when this server has finished sending him data, send him his ack now...
    print("received quit call, returning it to the client\n");

    $heap->{client}->put(\$cmd);
  }#elsif($cmd =~ /shutdown/i)
  elsif($cmd =~ /set/i)
  {
    my $argname;
    ($argname, $args) = split(/ /,$args,2) if($args);
    if($argname && $args)
    {
      $settings->{$argname} = $args;
      $msg .= "SET: $argname = '".$settings->{$argname}."'\n";

    }# if($args)
    elsif($argname)
    {
      $msg .= "Dumping setting:\n$argname = '".$settings->{$argname}."'\n";
    }# elsif($argname)
    else
    {
      $msg .= "-----  Dumping settings --------- :\n";
      #print("Dump settings requested.... ")

      foreach $argname (keys( %$settings ))
      {
	$msg .= "$argname = '".$settings->{$argname}."'\n";
      }# foreach $argname 
      $msg .= "-------  End list  ---------------\n";
    }#else
    #print("sending back settings\n");
    $heap->{client}->put(\$msg);
  }# elsif($cmd =~ /set/i)
  elsif($cmd =~ /printhandler/i)
  {
    if($args =~ /on/i)
    {
     if($printHandlers->{$session->ID})
     {
       #print("printhandler was allready marked as active....\n");
     }# if($printHandlers->{$session->ID})
     else
     {
       #print("printhandler activation....\n");
       my @pureclients;

       #print("actual list of clients:".Dumper(keys(%clients))."....\n");
       add_printhandler($session->ID,$kernel);
     }# else
    }# if($args =~ /on/i)
    else
    {
      if($printHandlers->{$session->ID})
      {
       rm_printhandler($session->ID,$kernel);
      }# if($printHandlers->{$session->ID})
      else
      {
	#print("printhandler isn't active so why desactivate??....\n");
      }

    }# else
  }#elsif($cmd =~ /print/i)
  elsif($cmd =~ /print/i)
  {
    #$printHandlers->{ } = $heap->{client};
    #print("PRINT invoqued with ".Dumper($args)."\n");
    #print("we need to forward ".$args->{"msg"}."\n");
    my @handlernames = keys(%$printHandlers);
    my $amsg = "print[".$args->{"origin"}."]: ".$args->{"msg"};
    foreach my $ahandler (@handlernames)
    {
      #print("post to session $ahandler '$amsg'\n");
      #my $debugging = "refs are :".$printHandlers->{$ahandler}." allclients:";
      #$debugging .= Dumper(\%clients)."\n";
      #print($debugging);
      $kernel->post( $ahandler => send => \$amsg );
    }# foreach my $ahandler(@handlernames)
    return("noack");
  }#elsif($cmd =~ /print/i)
  elsif($shCommands->{$cmd})
  {
    my $subname = $shCommands->{$cmd};
    #print("calling $subname of handler\n");
    $msg = $handler->$subname($args);
    #send nothing if there's no message...
    if($msg)
    {
      #print("actual message type = ".ref($msg)."\n");
      if(ref($msg eq "SCALAR") || !(ref($msg)))
      {
	#print("sending scalar back to client $msg\n");
	$heap->{client}->put(\$msg);
      }# if(ref($msg eq "SCALAR"))
      else
      {
	#print("sending (else) back to client ".Dumper($msg)."\n");
	#print("sending (else) back to client ".ref($msg)."\n");
	#print("sending (else) back to client ".$msg->{"url"}."\n");
	$heap->{client}->put($msg);
      }# else
    }# if($msg)
  }#elsif($shCommands->{$cmd})
  else
  {
    print("Nothing known about how to process $cmd sending\n".issueUsage()."\n");
    $msg = "Nothing known about how to process $cmd\n".issueUsage()."\n";
    $heap->{client}->put(\$msg);
  }#else
  return " ";
}#sub processCmd
##############################################################################
=pod

=item client_connection

a client connected, put it into the list of contactable clients

=cut
######################################################################
sub client_connection
{
  my ( $heap, $kernel,$session ) = @_[ HEAP, KERNEL,SESSION ];
  print("new client ".$session->ID." connected\n");
  $clients{$session->ID} = 1;

  my @handlernames = keys(%$printHandlers);
  if(scalar(@handlernames) > 0)
  {
    print("we are in redirection mode!!\n");
    my $activation = "redirectprinting on";
    $heap->{client}->put(\$activation);
  }# if(scalar(@{keys(%$printHandlers)}) <= 1)
}#sub client_connection
##############################################################################
=pod

=item handle_send

Handle an outgoing message by sending it to the client.

=cut
######################################################################
sub handle_send 
{
    my ( $heap, $message ) = @_[ HEAP, ARG0 ];
    #print("handle_send to sess:".$_[SESSION]->ID."i sending data with ".ref($heap->{client})." fetched from ".ref($heap)."\n");
    
    $heap->{client}->put($message);
}
##############################################################################
=pod

=item add_printhandler

Handle an outgoing message by sending it to the client.

=cut
######################################################################
sub add_printhandler 
{
  my($sessionid,$kernel) = @_;

	 $printHandlers->{$sessionid} = 1;
	 my @handlernames = keys(%$printHandlers);
       if(scalar(@handlernames) <= 1)
       {
	 #print("first activation!! need to inform all clients de redirect their output....\n");
	 foreach my $aclient (keys(%clients))
	 {
	   if( grep( ($_ ne $aclient), @handlernames))
	   {
	     #print("need to inform client: $aclient\n");
	      my $activation = "redirectprinting on";
                 $kernel->post( $aclient => send => \$activation );
	   }# if( grep( ($_ ne $aclient), @handlernames))
	   else
	   {
	     #print("session is a handler itself:$aclient\n");
	   }# else
	 }#foreach my $aclient (keys(%clients))
	 #print("done compiling inform list\n");
       }# if(scalar(@{keys(%$printHandlers)}) <= 1)
}#sub add_printhandler 
##############################################################################
=pod

=item  rm_printhandler

remove a pritnhandler from the list of handler and eventually inform the
attached processes of the new status

=cut
######################################################################
sub rm_printhandler 
{
  my($sessionid,$kernel) = @_;
  #print("removing printhandler from active active....\n");
  delete($printHandlers->{$sessionid}); 
  my @handlernames = keys(%$printHandlers);
  if(scalar(@handlernames) <= 0)
  {
    #print("last desactivation!! need to inform all clients to regain their output....\n");
    foreach my $aclient (keys(%clients))
    {
      if($aclient ne $sessionid)
      {
	print("need to inform client: $aclient\n");
	my $activation = "redirectprinting off";
	$kernel->post( $aclient => send => \$activation );
      }
    }#foreach my $aclient (keys(%clients))
    print("done compiling desinform list\n");
  }# if(scalar(@{keys(%$printHandlers)}) <= 1)
}#sub rm_printhandler 
__END__


=back

=head1 THANKS

I. Wronsky came up with the concept for leverloda
This gave B. Boettcher the incentive to begin this work, the
famous itching paradigm!

=head1 SEE ALSO

http://www.geocities.com/iwronsky/
http://poe.perl.org/

=cut

